package com.example.daytimeapp;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.net.Socket;
import java.net.UnknownHostException;
// import java.text.SimpleDateFormat;
import java.util.Calendar;
// import java.util.Date;

import android.util.Log;

public class ServerConnectorThread extends Thread {
	private static String HOST = "basen.oru.se";
	private static int PORT = 2005;
	private final MainActivity parent;
	// private static final SimpleDateFormat date_format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss.SSS Z");

	public ServerConnectorThread(MainActivity parent) {
		this.parent = parent;
	}

	public void run() {
		try {
			parent.print("Connecting to " + HOST + "...");
			Socket socket = new Socket(HOST, PORT);
			parent.print("Connected.");
			BufferedReader from_server = new BufferedReader(new InputStreamReader(socket.getInputStream()));
			PrintWriter to_server = new PrintWriter(new BufferedWriter(new OutputStreamWriter(socket.getOutputStream())), true);
			// true: PrintWriter is line buffered
			Log.d("*** ServerConnectorThread", "Waiting for a line from the server...");
			String line_from_server = from_server.readLine();

			// Here, so the time is as close as possible to the server's time
			Calendar now = Calendar.getInstance();
			
			Log.d("*** ServerConnectorThread", "Got line from server: '" + line_from_server + "'");
			if (line_from_server == null) {
				parent.print("Nothing to read from server.");
			}
			else {
				parent.print("Got line from server:");
				parent.print(line_from_server);
			}
			to_server.close();
			from_server.close();
			socket.close();
			String[] daytimeparts= line_from_server.split(" ");
			// for (String word : daytimeparts)
			//     parent.print("Ord: " + word);
			String time = daytimeparts[2];
			String[] timeparts = time.split(":");
			// for (String word : timeparts)
			//     parent.print("Time: " + word);
			int remote_hours = Integer.parseInt(timeparts[0]);
			int remote_minutes = Integer.parseInt(timeparts[1]);
			double remote_seconds = Double.parseDouble(timeparts[2]);
			
            parent.print("Remote time from " + HOST + ": " + remote_hours + ":" + remote_minutes + ":" + remote_seconds);
            
            double remote_seconds_since_midnight = remote_hours * 60 * 24 + remote_minutes * 60 + remote_seconds;
            // parent.print("remote seconds since midnight = " + remote_seconds_since_midnight);
            
            // String formatted_remote_date = date_format.format(now);
            // parent.print("Local time: " + formatted_local_date);

            int local_hours = now.get(Calendar.HOUR_OF_DAY);
            int local_minutes = now.get(Calendar.MINUTE);
            int local_seconds = now.get(Calendar.SECOND);
            int local_milliseconds = now.get(Calendar.MILLISECOND);

            parent.print("Local time: " + local_hours + ":" + local_minutes + ":" + local_seconds + "." + local_milliseconds);

            double local_seconds_since_midnight = local_hours * 60 * 24 + local_minutes * 60 + local_seconds + local_milliseconds / 1000.0;
            // parent.print("Local seconds since midnight = " + local_seconds_since_midnight);
            
            double difference = remote_seconds_since_midnight - local_seconds_since_midnight;
            parent.print("Difference = " + String.format("%.3f", difference) + " seconds");
		} catch (UnknownHostException e) {
			parent.print("Unknown host: " + e.getMessage());
		} catch (IOException e) {
			parent.print("I/O Exception: " + e.getMessage());
		}
	} // run
	
} // class ServerConnectorThread